program test
  
  use ACT_LIKELIHOOD_LENS

  integer,parameter   :: l_lens =2050
  character(LEN=128)  :: filename
  real(8)             :: cl_dd(2:l_lens),dum_r,like
  integer             ::il,dum_i
  
  call ACT_LIKELENS_INIT

  filename = 'data/test_cls.dat' !file is of camb output format
  write(*,*)"Reading in Cls from: ",trim(filename)

  call get_free_lun( lun )

  
  open(unit=lun,file=filename,action='read',status='old')
 
  cl_dd=0.d0
  do il=2,l_lens
     read(lun,*) dum_i, dum_r, dum_r, dum_r,cl_dd(il),dum_r
     cl_dd(il)=cl_dd(il)/(4.d0*(2.726d6)**2) !convert to l^2C_dd/4
  enddo
  close(lun)
  like=0.d0

  call act_likelens_compute(cl_dd,like)
  
  write(*,*)"  "
  write(*,*)"----------------------------------------"
  write(*,*)"ACT lensing -2ln(L)              = ",2*like
  write(*,*)"----------------------------------------"
  write(*,*)"Expected -2ln(L)                 =    6.49840"
  write(*,*)"----------------------------------------"    
  write(*,*)"  " 
  
end program test
